package com.soundapp.alisajung.ambientsounds;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;

import java.io.IOException;
import java.util.ArrayList;

public class PlaylistEditor extends AppCompatActivity implements AdapterView.OnItemClickListener {


    private ContentResolver contentResolver;
    private static String LOGTAG = "Media Importer";
    private ListView mediaListView;
    private Context context;
    private ArrayList arrayListTitles;
    private ArrayList<Long> arrayListIds;
    private ArrayAdapter arrayAdapater;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_playlist_editor);

        mediaListView = (ListView) findViewById(R.id.medialist1);
        ContentResolver cr = getContentResolver();

        Intent intent = getIntent();

        int message = intent.getIntExtra(ManagePlaylistsActivity.EDIT_MODE,-1);
        Log.d("Hilfe", "Test");
        Log.d("Hilfe", "Message: " + message);
        if (message == ManagePlaylistsActivity.PLAYLIST_ADD){
            Log.d("Hilfe", "bla");

            arrayListIds = new ArrayList<Long>();
            Log.d("Hilfe", "bla4");
            mediaListView.setOnItemClickListener(this);
            Log.d("Hilfe", "bla5");
            //loadMedia();
            //Log.d("Hilfe", "bla3");

        }
        else if (message == ManagePlaylistsActivity.PLAYLIST_EDIT){

        }
        else{
            Log.d("Hilfe", "FUCK FUCK FUCK "+message + " sollte " + ManagePlaylistsActivity.PLAYLIST_ADD);
        }
    }

    private void loadMedia() {
        Uri uri = android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI;
        Cursor cursor = contentResolver.query(uri, null, null, null, null);
        long lastid = 0;


        if (cursor == null) {
            Log.d(LOGTAG, "Cursor fail");
            // query failed, handle error.
        } else if (!cursor.moveToFirst()) {
            Log.d(LOGTAG, "Curser move fist fail");
            // no media on the device
        } else {
            Log.d(LOGTAG, "Stuff.");

            arrayListTitles = new ArrayList();
            arrayAdapater = new ArrayAdapter(context, android.R.layout.simple_list_item_1, arrayListTitles);
            mediaListView.setAdapter(arrayAdapater);
            int titleColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media.TITLE);
            int idColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media._ID);
            arrayListIds.clear();
            arrayListTitles.clear();
            do {
                long thisId = cursor.getLong(idColumn);
                String thisTitle = cursor.getString(titleColumn);

                Log.d(LOGTAG, "Logging!" + thisTitle);
                // ...process entry...
                lastid = thisId;
                arrayListTitles.add(thisTitle);
                arrayListIds.add(thisId);
            } while (cursor.moveToNext());

//            playSongWithID(lastid);

        }
    }

    public void playSongWithID(long id){
        Log.d(LOGTAG, "Try playing ");
        Uri contentUri = ContentUris.withAppendedId(
                android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, id);

        MediaPlayer mMediaPlayer = new MediaPlayer();
        mMediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
        try {
            mMediaPlayer.setDataSource(context, contentUri);
        } catch (IOException e) {
            Log.d(LOGTAG, "Fail. mist.");
            e.printStackTrace();
        }
        try {
            mMediaPlayer.prepare();
        } catch (IOException e) {
            e.printStackTrace();
        }
        mMediaPlayer.start();
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        playSongWithID(arrayListIds.get(position));
    }
}
